Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 5075)
@@ -6,30 +6,42 @@
 !
 ! DESCRIPTION:
-!> @brief
-!> This module is a library to read/write Netcdf file.
+!> @brief NETCDF Input/Output manager :  Library to read Netcdf input files
 !>
 !> @details
-!>
 !>    to open netcdf file:<br/>
+!> @code
 !>    CALL iom_cdf_open(td_file)
-!>       - td_file is file structure (see file.f90)
+!> @endcode
+!>       - td_file is file structure (see @ref file)
 !>
 !>    to write in netcdf file:<br/>
+!> @code
 !>    CALL  iom_cdf_write_file(td_file)
+!> @endcode
 !>
 !>    to close netcdf file:<br/>
+!> @code
 !>    CALL iom_cdf_close(tl_file)
+!> @endcode
 !>
 !>    to read one dimension in netcdf file:<br/>
-!>    tl_dim = iom_cdf_read_dim(tl_file, id_dimid)<br/>
-!>    or<br/>
+!> @code
+!>    tl_dim = iom_cdf_read_dim(tl_file, id_dimid)
+!> @endcode
+!>    or
+!> @code
 !>    tl_dim = iom_cdf_read_dim(tl_file, cd_name)
+!> @endcode
 !>       - id_dimid is dimension id<br/>
 !>       - cd_name is dimension name
 !>
-!>    to read one global attribute in netcdf file:<br/>
-!>    tl_att = iom_cdf_read_att(tl_file, id_varid, id_attid)<br/>
-!>    or<br/>
+!>    to read one attribute in netcdf file:<br/>
+!> @code
+!>    tl_att = iom_cdf_read_att(tl_file, id_varid, id_attid)
+!> @endcode
+!>    or
+!> @code
 !>    tl_att = iom_cdf_read_att(tl_file, id_varid, cd_name)
+!> @endcode
 !>       - id_varid is variable id
 !>       - id_attid is attribute id<br/>
@@ -37,33 +49,24 @@
 !>    
 !>    to read one variable in netcdf file:<br/>
-!>    tl_var = iom_cdf_read_var(td_file, id_varid, [id_start, id_count])<br/>
-!>    or<br/>
-!>    tl_var = iom_cdf_read_var(td_file, cd_name, [id_start, [id_count,]] [cd_stdname])
+!> @code
+!>    tl_var = iom_cdf_read_var(td_file, id_varid, [id_start, id_count])
+!> @endcode
+!>    or
+!> @code
+!>    tl_var = iom_cdf_read_var(td_file, cd_name, [id_start, [id_count,]])
+!> @endcode
 !>       - id_varid is variabale id
 !>       - cd_name is variabale name
-!>       - id_start is a integer(4) 1D table of index from which the data 
-!>          values will be read (optional)
-!>       - id_count is a integer(4) 1D table of the number of indices selected
-!>          along each dimension (optional)
-!>       - cd_stdname is variable standard name (optional)
+!>       - id_start is a integer(4) 1D array of index from which the data 
+!>          values will be read [optional]
+!>       - id_count is a integer(4) 1D array of the number of indices selected
+!>          along each dimension [optional]
 !>
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!
-!> @param MyModule_type : brief_description
+!> @date November, 2013 - Initial Version
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!
-!> @todo 
-!> - inform variable pni, pnj, pnij, area, iglo, jglo 
-!> - use var_init when read new variable
-!> - use dim_init when read new dimension
-!> - use att_init when read new attribute
-!> - add read td_dom
-!> @todo
-!> - voir si il ne faut pas redefinir (__copy) variable si elle vient de mpp
-!> exemple CALL  mpp_move_var( td_mpp, td_mpp%t_var )
 !----------------------------------------------------------------------
 MODULE iom_cdf
@@ -72,13 +75,10 @@
    USE kind                            ! F90 kind parameter
    USE fct                             ! basic useful function
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE att                             ! attribute manage
    USE dim                             ! dimension manager
    USE var                             ! variable manager
    USE file                            ! file manager
-   USE dom                             ! domain manager
-!   USE proc                            ! processor manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
@@ -91,30 +91,29 @@
    PUBLIC :: iom_cdf_fill_var    !< fill variable value in an opened netcdf file
    PUBLIC :: iom_cdf_write_file  !< write file structure contents in an opened netcdf file
-   ! PUBLIC :: iom_cdf_get_mpp     ! get sub domain decomposition in a netcdf file
-
-   PRIVATE :: iom_cdf__check           !< provides a simple interface to netcdf error message
-   PRIVATE :: iom_cdf__get_info        !< get global information in an opened netcdf file
-   PRIVATE :: iom_cdf__get_file_dim    !< read dimension on an opened netcdf file, and reorder it
-   PRIVATE :: iom_cdf__get_file_att    !< read global attribute on an opened netcdf file
-   PRIVATE :: iom_cdf__get_file_var    !< read information about variable on an opened netcdf file
-   PRIVATE :: iom_cdf__read_dim_id     !< read one dimension in an opened netcdf file, given dimension id.
-   PRIVATE :: iom_cdf__read_dim_name   !< read one dimension in an opened netcdf file, given dimension name.
-   PRIVATE :: iom_cdf__read_att_name   !< read variable or global attribute in an opened netcdf file, given attribute name. 
-   PRIVATE :: iom_cdf__read_att_id     !< read variable or global attribute in an opened netcdf file, given attribute id.
-   PRIVATE :: iom_cdf__read_var_id     !< read variable value in an opened netcdf file, given variable id.
-   PRIVATE :: iom_cdf__read_var_name   !< read variable value in an opened netcdf file, given variable name or standard name.
-   PRIVATE :: iom_cdf__read_var_meta   !< read metadata of a variable in an opened netcdf file.
-   PRIVATE :: iom_cdf__read_var_dim    !< read variable dimension in an opened netcdf file.
-   PRIVATE :: iom_cdf__read_var_att    !< read variable attributes in an opened netcdf file.
-   PRIVATE :: iom_cdf__read_var_value  !< read variable value in an opened netcdf file.
-   PRIVATE :: iom_cdf__write_dim       !< write one dimension in an opened netcdf file in write mode.
-   PRIVATE :: iom_cdf__write_att       !< write a variable attribute in an opened netcdf file.
-   PRIVATE :: iom_cdf__write_var       !< write a variable in an opened netcdf file.
-   PRIVATE :: iom_cdf__write_var_def   !< define variable in an opened netcdf file.
-   PRIVATE :: iom_cdf__write_var_value !< put variable value in an opened netcdf file.
-   PRIVATE :: iom_cdf__fill_var_id     !< fill variable value in an opened netcdf file, given variable id
-   PRIVATE :: iom_cdf__fill_var_name   !< fill variable value in an opened netcdf file, given variable name
-   PRIVATE :: iom_cdf__fill_var_all    !< fill all variable value in an opened netcdf file
-   PRIVATE :: iom_cdf__del_var_dim     !< remove variable dimension from an opened netcdf file
+
+   PRIVATE :: iom_cdf__check           ! provides a simple interface to netcdf error message
+   PRIVATE :: iom_cdf__get_info        ! get global information in an opened netcdf file
+   PRIVATE :: iom_cdf__get_file_dim    ! read dimension on an opened netcdf file, and reorder it
+   PRIVATE :: iom_cdf__get_file_att    ! read global attribute on an opened netcdf file
+   PRIVATE :: iom_cdf__get_file_var    ! read information about variable on an opened netcdf file
+   PRIVATE :: iom_cdf__read_dim_id     ! read one dimension in an opened netcdf file, given dimension id.
+   PRIVATE :: iom_cdf__read_dim_name   ! read one dimension in an opened netcdf file, given dimension name.
+   PRIVATE :: iom_cdf__read_att_name   ! read variable or global attribute in an opened netcdf file, given attribute name. 
+   PRIVATE :: iom_cdf__read_att_id     ! read variable or global attribute in an opened netcdf file, given attribute id.
+   PRIVATE :: iom_cdf__read_var_id     ! read variable value in an opened netcdf file, given variable id.
+   PRIVATE :: iom_cdf__read_var_name   ! read variable value in an opened netcdf file, given variable name or standard name.
+   PRIVATE :: iom_cdf__read_var_meta   ! read metadata of a variable in an opened netcdf file.
+   PRIVATE :: iom_cdf__read_var_dim    ! read variable dimension in an opened netcdf file.
+   PRIVATE :: iom_cdf__read_var_att    ! read variable attributes in an opened netcdf file.
+   PRIVATE :: iom_cdf__read_var_value  ! read variable value in an opened netcdf file.
+   PRIVATE :: iom_cdf__write_dim       ! write one dimension in an opened netcdf file in write mode.
+   PRIVATE :: iom_cdf__write_att       ! write a variable attribute in an opened netcdf file.
+   PRIVATE :: iom_cdf__write_var       ! write a variable in an opened netcdf file.
+   PRIVATE :: iom_cdf__write_var_def   ! define variable in an opened netcdf file.
+   PRIVATE :: iom_cdf__write_var_value ! put variable value in an opened netcdf file.
+   PRIVATE :: iom_cdf__fill_var_id     ! fill variable value in an opened netcdf file, given variable id
+   PRIVATE :: iom_cdf__fill_var_name   ! fill variable value in an opened netcdf file, given variable name
+   PRIVATE :: iom_cdf__fill_var_all    ! fill all variable value in an opened netcdf file
+   PRIVATE :: iom_cdf__del_coord_var   ! remove coordinate variable from an opened netcdf file
 
    INTERFACE iom_cdf_read_var
@@ -145,9 +144,8 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] id_status : error status
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] id_status error status
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__check(id_status)
       IMPLICIT NONE
@@ -161,9 +159,9 @@
 
    END SUBROUTINE iom_cdf__check
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine open a netcdf file in read or write mode<br/>
+   !-------------------------------------------------------------------
+   !> @brief This subroutine open a netcdf file in read or write mode.
+   !> @details
    !> if try to open a file in write mode that did not exist, create it.<br/>
-   !> if file already exist, get information about:
+   !> if file already exist, get information about0:<br/>
    !> - the number of variables
    !> - the number of dimensions
@@ -171,12 +169,12 @@
    !> - the ID of the unlimited dimension
    !> - the file format
-   !> and finally read dimensions.
+   !> Finally it read dimensions, and 'longitude' variable to compute East-West
+   !> overlap.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf_open(td_file)
       IMPLICIT NONE
@@ -189,8 +187,4 @@
 
       INTEGER(i4) :: il_status
-
-      TYPE(TVAR)  :: tl_lon
-      ! loop indices
-      INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
@@ -202,11 +196,10 @@
          IF( .NOT. td_file%l_wrt )THEN
 
-            CALL logger_fatal( " OPEN: can not open file "//&
+            CALL logger_fatal( " IOM CDF OPEN: can not open file "//&
             &               TRIM(td_file%c_name) )
-            td_file%i_id=-1
-         
+ 
          ELSE
 
-            CALL logger_info( " CREATE: file "//TRIM(td_file%c_name) )
+            CALL logger_info( " IOM CDF CREATE: file "//TRIM(td_file%c_name) )
 
             il_status = NF90_CREATE( TRIM(td_file%c_name),&
@@ -220,26 +213,25 @@
 
       ELSE
-
          IF( td_file%i_id /= 0 )THEN
 
-            CALL logger_error( " OPEN: file "//&
+            CALL logger_error( " IOM CDF OPEN: file "//&
             &               TRIM(td_file%c_name)//" already opened")
 
          ELSE
-
+ 
             IF( .NOT. td_file%l_wrt )THEN
 
-               CALL logger_info( " OPEN: file "//&
+               CALL logger_info( " IOM CDF OPEN: file "//&
                &              TRIM(td_file%c_name)//" in read only mode" )
 
                il_status = NF90_OPEN( TRIM(td_file%c_name), &
-               &                      NF90_NOWRITE,              &
+               &                      NF90_NOWRITE,         &
                &                      td_file%i_id)
                CALL iom_cdf__check(il_status)
 
-               CALL logger_debug("OPEN "//TRIM(td_file%c_name)//" "//TRIM(fct_str(td_file%i_id)))
+               CALL logger_trace("IOM CDF OPEN "//TRIM(td_file%c_name)//" "//TRIM(fct_str(td_file%i_id)))
             ELSE
 
-               CALL logger_info( " OPEN: file "//&
+               CALL logger_info( "IOM CDF OPEN: file "//&
                &              TRIM(td_file%c_name)//" in write mode" )
 
@@ -263,19 +255,6 @@
             CALL iom_cdf__get_file_var(td_file)
 
-            ! get ew overlap
-            tl_lon=iom_cdf_read_var(td_file,'longitude')
-            td_file%i_ew=dom_get_ew_overlap(tl_lon)
-            CALL logger_debug(" IOM OPEN EW "//TRIM(fct_str(td_file%i_ew)) )
-            WHERE( td_file%t_var(:)%t_dim(1)%l_use )
-               td_file%t_var(:)%i_ew=td_file%i_ew
-            END WHERE
-            CALL var_clean(tl_lon)
-
-            DO ji=1,td_file%i_nvar
-               CALL logger_debug(TRIM(td_file%t_var(ji)%c_name)//": "//TRIM(fct_str(td_file%t_var(ji)%i_ew)) )
-            ENDDO
- 
             ! remove dimension variable from list of variable
-            CALL iom_cdf__del_var_dim(td_file)
+            CALL iom_cdf__del_coord_var(td_file)
 
          ENDIF
@@ -284,14 +263,12 @@
 
    END SUBROUTINE iom_cdf_open
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine close netcdf file
+   !-------------------------------------------------------------------
+   !> @brief This subroutine close netcdf file.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf_close(td_file)
       IMPLICIT NONE
@@ -307,9 +284,9 @@
 
          CALL logger_error( &
-         &  " CLOSE: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF CLOSE: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE
          CALL logger_info( &
-         &  " CLOSE: file "//TRIM(td_file%c_name))
+         &  " IOM CDF CLOSE: file "//TRIM(td_file%c_name))
 
          il_status = NF90_CLOSE(td_file%i_id)
@@ -321,8 +298,7 @@
 
    END SUBROUTINE iom_cdf_close
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine get global information in an opened netcdf 
-   !> file.<br/>
+   !> file.
    !> @details
    !> It gets the number of variables, the number of dimensions, 
@@ -331,10 +307,8 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__get_info(td_file)
       IMPLICIT NONE
@@ -348,5 +322,5 @@
 
       CALL logger_trace( &
-      &  " GET INFO: about netcdf file "//TRIM(td_file%c_name))
+      &  " IOM CDF GET INFO: about netcdf file "//TRIM(td_file%c_name))
 
       il_status=NF90_INQUIRE(td_file%i_id, td_file%i_ndim, &
@@ -365,17 +339,14 @@
 
    END SUBROUTINE iom_cdf__get_info
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine read dimension on an opened netcdf file, and
-   !> reorder dimension to ('x', 'y', 'z', 't').<br/>
+   !> reorder dimension to ('x', 'y', 'z', 't').
    !> The dimension structure inside file structure is then completed.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__get_file_dim(td_file)
       IMPLICIT NONE
@@ -401,5 +372,5 @@
          IF( td_file%i_uldid == -1 )THEN
             CALL logger_warn( &
-            &  " GET FILE DIM: there is no unlimited dimension in file "//&
+            &  " IOM CDF GET FILE DIM: there is no unlimited dimension in file "//&
             &  TRIM(td_file%c_name))
          ELSE
@@ -410,5 +381,5 @@
 
          CALL logger_warn( &
-         &  " GET FILE DIM: there is no dimension in file "//&
+         &  " IOM CDF GET FILE DIM: there is no dimension in file "//&
          &  TRIM(td_file%c_name))
 
@@ -419,17 +390,16 @@
 
    END SUBROUTINE iom_cdf__get_file_dim
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine read global attribute on an opened netcdf 
-   !> file.<br/>
+   !> file.
    !> The attribute structure inside file structure is then completed.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - use attribute periodicity read from the file if present.
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__get_file_att(td_file)
       IMPLICIT NONE
@@ -437,4 +407,5 @@
       TYPE(TFILE), INTENT(INOUT) :: td_file
 
+      ! local variable
       ! loop indices
       INTEGER(i4) :: ji
@@ -443,4 +414,5 @@
       IF( td_file%i_natt > 0 )THEN
          IF(ASSOCIATED(td_file%t_att))THEN
+            CALL att_clean(td_file%t_att(:))
             DEALLOCATE(td_file%t_att)
          ENDIF
@@ -451,36 +423,24 @@
             td_file%t_att(ji)=iom_cdf_read_att( td_file, NF90_GLOBAL, ji)
             
-            SELECT CASE(TRIM(td_file%t_att(ji)%c_name))
-               CASE('periodicity')
-                  td_file%i_perio=INT(td_file%t_att(ji)%d_value(1),i4)
-               CASE('pivot_point')
-                  td_file%i_pivot=INT(td_file%t_att(ji)%d_value(1),i4)
-               CASE('ew_overlap')
-                  td_file%i_ew=INT(td_file%t_att(ji)%d_value(1),i4)
-            END SELECT
-
          ENDDO
 
       ELSE
          CALL logger_debug( &
-         &  " GET FILE ATT: there is no global attribute in file "//&
+         &  " IOM CDF GET FILE ATT: there is no global attribute in file "//&
          &  TRIM(td_file%c_name))
       ENDIF
 
    END SUBROUTINE iom_cdf__get_file_att
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This subroutine read information about variable of an 
-   !> opened netcdf file.<br/>
+   !> opened netcdf file.
    !> The variable structure inside file structure is then completed.
    !> @note variable value are not read !
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__get_file_var(td_file)
       IMPLICIT NONE
@@ -497,4 +457,5 @@
       IF( td_file%i_nvar > 0 )THEN
          IF(ASSOCIATED(td_file%t_var))THEN
+            CALL var_clean(td_file%t_var(:))
             DEALLOCATE(td_file%t_var)
          ENDIF
@@ -504,5 +465,4 @@
             ! read dimension information
             td_file%t_var(ji)=iom_cdf__read_var_meta( td_file, ji)
-
             SELECT CASE(td_file%t_var(ji)%i_ndim)
                CASE(0)
@@ -524,7 +484,9 @@
                   td_file%i_depthid=ji
                ELSE
-                  CALL logger_error("IOM OPEN: find more than one "//&
-                  &                 "depth variable in file "//&
-                  &                 TRIM(td_file%c_name) )
+                  IF( td_file%i_depthid /= ji )THEN
+                     CALL logger_error("IOM CDF GET FILE VAR: find more than one "//&
+                     &                 "depth variable in file "//&
+                     &                 TRIM(td_file%c_name) )
+                  ENDIF
                ENDIF
             ENDIF
@@ -554,21 +516,19 @@
       ELSE
          CALL logger_debug( &
-         &  " GET FILE VAR: there is no variable in file "//&
+         &  " IOM CDF GET FILE VAR: there is no variable in file "//&
          &  TRIM(td_file%c_name))
       ENDIF
 
    END SUBROUTINE iom_cdf__get_file_var
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine delete variable dimension from an 
-   !> opened netcdf file.<br/>
-   !
-   !> @author J.Paul
-   !> - 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_cdf__del_var_dim(td_file)
+   !-------------------------------------------------------------------
+   !> @brief This subroutine delete coordinate variable from an 
+   !> opened netcdf file if present.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
+   SUBROUTINE iom_cdf__del_coord_var(td_file)
       IMPLICIT NONE
       ! Argument      
@@ -598,87 +558,8 @@
       ELSE
          CALL logger_debug( &
-         &  " DEL VAR DIM: there is no variable in file "//&
+         &  " IOM CDF DEL VAR DIM: there is no variable in file "//&
          &  TRIM(td_file%c_name))
       ENDIF
-   END SUBROUTINE iom_cdf__del_var_dim
-   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief This subroutine get variable time from an 
-!   !> opened netcdf file.<br/>
-!   !
-!   !> @author J.Paul
-!   !> - 2013- Initial Version
-!   !
-!   !> @param[inout] td_file : file structure
-!   !-------------------------------------------------------------------
-!   !> @code
-!   SUBROUTINE iom_cdf__get_var_time(td_file)
-!      IMPLICIT NONE
-!      ! Argument      
-!      TYPE(TFILE), INTENT(INOUT) :: td_file
-!
-!      ! local variable
-!      CHARACTER(LEN=lc) :: cl_name
-!
-!      ! loop indices
-!      INTEGER(i4) :: ji
-!      !----------------------------------------------------------------
-!      IF( td_file%i_nvar > 0 )THEN
-!         DO ji=1,td_file%i_nvar
-!            cl_name=TRIM(td_file%t_var(ji)%c_name)
-!            IF( INDEX(cl_name,'time') /= 0 )THEN
-!               ! read time variable
-!               td_file%t_time=iom_cdf_read_var(td_file,ji)
-!               ! remove time variable from variable list
-!               CALL file_del_ver(td_file,TRIM(cl_name))
-!               EXIT
-!            ENDIF
-!         ENDDO
-!      ELSE
-!         CALL logger_debug( &
-!         &  " GET VAR TIME: there is no variable in file "//&
-!         &  TRIM(td_file%c_name))
-!      ENDIF
-!   END SUBROUTINE iom_cdf__get_var_time
-!   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief This subroutine get variable depth from an 
-!   !> opened netcdf file.<br/>
-!   !
-!   !> @author J.Paul
-!   !> - 2013- Initial Version
-!   !
-!   !> @param[inout] td_file : file structure
-!   !-------------------------------------------------------------------
-!   !> @code
-!   SUBROUTINE iom_cdf__get_var_depth(td_file)
-!      IMPLICIT NONE
-!      ! Argument      
-!      TYPE(TFILE), INTENT(INOUT) :: td_file
-!
-!      ! local variable
-!      CHARACTER(LEN=lc) :: cl_name
-!
-!      ! loop indices
-!      INTEGER(i4) :: ji
-!      !----------------------------------------------------------------
-!      IF( td_file%i_nvar > 0 )THEN
-!         DO ji=1,td_file%i_nvar
-!            cl_name=TRIM(td_file%t_var(ji)%c_name)
-!            IF( INDEX(cl_name,'depth') /= 0 )THEN
-!               ! read depth variable
-!               td_file%t_depth=iom_cdf_read_var(td_file,ji)
-!               ! remove depth variable from variable list
-!               CALL file_del_ver(td_file,TRIM(cl_name))
-!               EXIT
-!            ENDIF
-!         ENDDO
-!      ELSE
-!         CALL logger_debug( &
-!         &  " GET VAR TIME: there is no variable in file "//&
-!         &  TRIM(td_file%c_name))
-!      ENDIF
-!   END SUBROUTINE iom_cdf__get_var_depth
-!   !> @endcode
+   END SUBROUTINE iom_cdf__del_coord_var
    !-------------------------------------------------------------------
    !> @brief This function read one dimension in an opened netcdf file, 
@@ -686,11 +567,10 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_dimid : dimension id
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_dimid  dimension id
    !> @return  dimension structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TDIM) FUNCTION iom_cdf__read_dim_id(td_file, id_dimid)
       IMPLICIT NONE
@@ -709,5 +589,5 @@
 
          CALL logger_error( &
-         &  " READ DIM: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF READ DIM: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE      
@@ -715,6 +595,6 @@
          iom_cdf__read_dim_id%i_id=id_dimid
 
-         CALL logger_debug( &
-         &  " READ DIM: dimension "//TRIM(fct_str(id_dimid))//&
+         CALL logger_trace( &
+         &  " IOM CDF READ DIM: dimension "//TRIM(fct_str(id_dimid))//&
          &  " in file "//TRIM(td_file%c_name))
 
@@ -728,5 +608,4 @@
 
    END FUNCTION iom_cdf__read_dim_id
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function read one dimension in an opened netcdf file, 
@@ -734,11 +613,10 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] cd_name : dimension name
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] cd_name   dimension name
    !> @return  dimension structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TDIM) FUNCTION iom_cdf__read_dim_name(td_file, cd_name)
       IMPLICIT NONE
@@ -756,5 +634,5 @@
 
          CALL logger_error( &
-         &  " READ DIM: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF READ DIM: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE      
@@ -769,5 +647,4 @@
 
    END FUNCTION iom_cdf__read_dim_name
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This function read variable or global attribute in an opened 
@@ -775,13 +652,12 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_varid : variable id. use NF90_GLOBAL to read global
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_varid  variable id. use NF90_GLOBAL to read global
    !> attribute in a file
-   !> @param[in] cd_name : attribute name
+   !> @param[in] cd_name   attribute name
    !> @return  attribute structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TATT) FUNCTION iom_cdf__read_att_name(td_file, id_varid, cd_name)
       IMPLICIT NONE
@@ -800,4 +676,5 @@
 
       CHARACTER(LEN=lc) :: cl_value
+      
       INTEGER(i1), DIMENSION(:), ALLOCATABLE :: bl_value
       INTEGER(i2), DIMENSION(:), ALLOCATABLE :: sl_value
@@ -810,5 +687,5 @@
 
          CALL logger_error( &
-         &  " READ ATT: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF READ ATT: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE      
@@ -819,12 +696,12 @@
          IF( id_varid == NF90_GLOBAL )THEN
 
-            CALL logger_debug( &
-            &  " READ ATT: inquire global attribute "//&
+            CALL logger_trace( &
+            &  " IOM CDF READ ATT: inquire global attribute "//&
             &  " in file "//TRIM(td_file%c_name))
 
          ELSE
 
-            CALL logger_debug( &
-            &  " READ ATT: inquire attribute "//&
+            CALL logger_trace( &
+            &  " IOM CDF READ ATT: inquire attribute "//&
             &  " of variable "//TRIM(fct_str(id_varid))//&
             &  " in file "//TRIM(td_file%c_name))
@@ -840,5 +717,5 @@
 
          !! get attribute value
-         CALL logger_debug( " READ ATT: get attribute "//TRIM(cl_name)//&
+         CALL logger_debug( " IOM CDF READ ATT: get attribute "//TRIM(cl_name)//&
          &               " in file "//TRIM(td_file%c_name))
 
@@ -851,5 +728,5 @@
 
                   CALL logger_error( &
-                  &  " READ ATT: not enough space to put attribute "//&
+                  &  " IOM CDF READ ATT: not enough space to put attribute "//&
                   &  TRIM(cl_name) )
 
@@ -872,7 +749,6 @@
                IF(il_status /= 0 )THEN
 
-                  CALL logger_error( &
-                  &  " READ ATT: not enough space to put attribute "//&
-                  &  TRIM(cl_name) )
+                  CALL logger_error( "IOM CDF READ ATT: "//&
+                  &  "not enough space to put attribute "//TRIM(cl_name) )
 
                ELSE
@@ -897,5 +773,5 @@
 
                   CALL logger_error( &
-                  &  " READ ATT: not enough space to put attribute "//&
+                  &  " IOM CDF READ ATT: not enough space to put attribute "//&
                   &  TRIM(cl_name) )
 
@@ -921,5 +797,5 @@
 
                   CALL logger_error( &
-                  &  " READ ATT: not enough space to put attribute "//&
+                  &  " IOM CDF READ ATT: not enough space to put attribute "//&
                   &  TRIM(cl_name) )
 
@@ -944,5 +820,5 @@
 
                   CALL logger_error( &
-                  &  " READ ATT: not enough space to put attribute "//&
+                  &  " IOM CDF READ ATT: not enough space to put attribute "//&
                   &  TRIM(cl_name) )
 
@@ -968,5 +844,5 @@
 
                   CALL logger_error( &
-                  &  " READ ATT: not enough space to put attribute "//&
+                  &  " IOM CDF READ ATT: not enough space to put attribute "//&
                   &  TRIM(cl_name) )
 
@@ -992,5 +868,4 @@
 
    END FUNCTION iom_cdf__read_att_name
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This function read variable or global attribute in an opened 
